//  SettingsStopController.m

#import "SettingsStopController.h"
#import "ModelSettings.h"
#import <AsReaderDockSDK/AsReaderDockSDK.h>

@interface SettingsStopController ()<UITextFieldDelegate>
{
    
}

@property (weak, nonatomic) IBOutlet UITextField *olStopTagCount;
@property (weak, nonatomic) IBOutlet UITextField *olStopTime;
@property (weak, nonatomic) IBOutlet UITextField *olStopCycle;
@end

@implementation SettingsStopController

#pragma mark - Lifecycle
//----------------------------------------------------------------
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    int nTagCount = [AsReaderInfo sharedInstance].count;
    int nScanTime = [AsReaderInfo sharedInstance].scanTime;
    int nCycle = [AsReaderInfo sharedInstance].cycle;
    
    self.olStopTagCount.text = [NSString stringWithFormat:@"%d",nTagCount];
    self.olStopTime.text = [NSString stringWithFormat:@"%d",nScanTime];
    self.olStopCycle.text = [NSString stringWithFormat:@"%d",nCycle];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    [self setOlStopTagCount:nil];
    [self setOlStopTime:nil];
    [self setOlStopCycle:nil];
}

#pragma mark - IBAction
//----------------------------------------------------------------
- (IBAction)rightBarButtonItemClicked:(id)sender
{
    [self.olStopTagCount resignFirstResponder];
    [self.olStopTime resignFirstResponder];
    [self.olStopCycle resignFirstResponder];
       
    int stopTagCount = (int)[self.olStopTagCount.text integerValue];
    int stopTime = (int)[self.olStopTime.text integerValue];
    int stopCycle = (int)[self.olStopCycle.text integerValue];
    
    [[NSUserDefaults standardUserDefaults] setInteger:stopTagCount forKey:@"RFIDScanTagCount"];
    [[NSUserDefaults standardUserDefaults] setInteger:stopTime forKey:@"RFIDScanTagTime"];
    [[NSUserDefaults standardUserDefaults] setInteger:stopCycle forKey:@"RFIDScanTagInventory"];
    
    [[AsReaderRFIDDevice sharedInstance] setTagCount:stopTagCount setScanTime:stopTime setCycle:stopCycle];
}

#pragma mark - UITextView Delegate
//----------------------------------------------------------------
- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string
{
    NSString *str = [NSString stringWithFormat:@"%@%@", textField.text, string];
    int i = [str intValue];
    if (textField == self.olStopTagCount || textField == self.olStopTime) {
        if (i < 0 || i > 255) {
            return NO;
        }
    } else if (textField == self.olStopCycle) {
        if (i < 0 || i > 65535) {
            return NO;
        }
    }
    return YES;
}

@end
